// Doc_Arduino - german Arduino Forum
#pragma once


#if defined(ARDUINO_AVR_NANO_EVERY) && defined(__AVR_ATmega4809__)
    // is defined
    #include <NanoEveryPin.h>
#else
    #error "This library only support Arduino Nano Every Board with ATmega4809."
#endif
 
#define INLINE inline __attribute__((always_inline))

using namespace NanoEvery::Pin;
using Register = volatile uint8_t *;
    
// for Debugging and Tests etc.

// ------------------ VPORTs ----------------------------------------------------------------------------------------------- //                
constexpr Register getRegVPORTdir(const uint8_t pin)       { return (Register) regVPORTdir(pin); }
constexpr Register getRegVPORTdirPORTA(const uint8_t pin)  { return (Register) regVPORTdirPORTA(pin); }
constexpr Register getRegVPORTout(const uint8_t pin)       { return (Register) regVPORTout(pin); }
constexpr Register getRegVPORTin(const uint8_t pin)        { return (Register) regVPORTin(pin); }
constexpr Register getRegVPORTflag(const uint8_t pin)      { return (Register) regVPORTflag(pin); }

// ------------------ NORMAL PORTs ----------------------------------------------------------------------------------------- //
constexpr Register getRegPORTdirClear(const uint8_t pin)   { return (Register) regPORTdirClear(pin); }
constexpr Register getRegPORTin(const uint8_t pin)         { return (Register) regPORTin(pin); }
constexpr Register getRegPORTdirSet(const uint8_t pin)     { return (Register) regPORTdirSet(pin); }
constexpr Register getRegPORToutSet(const uint8_t pin)     { return (Register) regPORToutSet(pin); }
constexpr Register getRegPORToutClear(const uint8_t pin)   { return (Register) regPORToutClear(pin); }
constexpr Register getRegPORToutToggle(const uint8_t pin)  { return (Register) regPORToutToggle(pin); }
constexpr Register getRegPORTflag(const uint8_t pin)       { return (Register) regPORTflag(pin); }

// ------------------ SPECIALs ------------------ //
constexpr Register getRegPortCtrl(const uint8_t pin)       { return (Register) regPortCtrl(pin); }
constexpr Register getRegPinCtrl(const uint8_t pin)        { return (Register) regPinCtrl(pin); }
constexpr Register getRegPinCtrlPORTA(const uint8_t pin)   { return (Register) regPinCtrlPORTA(pin); }
  
      
     
constexpr uint16_t getAddrBaseVPORT(const uint8_t pin)    { return baseAddr[pin].vport; }
constexpr uint16_t getAddrBasePORT(const uint8_t pin)     { return baseAddr[pin].port; }
//constexpr uint8_t  getAddrOffsetVPORT(const uint8_t pin)  { return static_cast<uint8_t> (reinterpret_cast<uint16_t>(reg) - getAddrBaseVPORT(pin) ); }
//constexpr uint16_t getAddrAbsolut(Register reg) { return reinterpret_cast<uint16_t>(reg); }


/*
  anders, nochmal die gleichen Funktionen zum Bits setzen, aber diesmal zum Inhalt auslesen, Inhaltrückgabewert in Byte - Methodenüberladung
  
  um dann zu 'enableSlewRate' eine 'readSlewRate' Methode zu haben
*/

  