// Doc_Arduino - german Arduino Forum
// 04.02.2021

#pragma once


#if defined(ARDUINO_AVR_NANO_EVERY) && defined(__AVR_ATmega4809__)
    // is defined
    #include <NanoEveryPin.h>
#else
    #error "This library only support Arduino Nano Every Board with ATmega4809."
#endif
 
#define INLINE inline __attribute__((always_inline))

using namespace NanoEvery::Pin;
using Register = volatile uint8_t *;
    
// for Debugging and Tests etc.

// ------------------ VPORTs ----------------------------------------------------------------------------------------------- //                
constexpr Register getRegVPORTdir(const uint8_t pin)       { return (Register) regVPORTdir(pin); }
constexpr Register getRegVPORTdirPORTA(const uint8_t pin)  { return (Register) regVPORTdirPORTA(pin); }
constexpr Register getRegVPORTout(const uint8_t pin)       { return (Register) regVPORTout(pin); }
constexpr Register getRegVPORTin(const uint8_t pin)        { return (Register) regVPORTin(pin); }
constexpr Register getRegVPORTflag(const uint8_t pin)      { return (Register) regVPORTflag(pin); }

// ------------------ NORMAL PORTs ----------------------------------------------------------------------------------------- //
constexpr Register getRegPORTdirClear(const uint8_t pin)   { return (Register) regPORTdirClear(pin); }
constexpr Register getRegPORTin(const uint8_t pin)         { return (Register) regPORTin(pin); }
constexpr Register getRegPORTdirSet(const uint8_t pin)     { return (Register) regPORTdirSet(pin); }
constexpr Register getRegPORToutSet(const uint8_t pin)     { return (Register) regPORToutSet(pin); }
constexpr Register getRegPORToutClear(const uint8_t pin)   { return (Register) regPORToutClear(pin); }
constexpr Register getRegPORToutToggle(const uint8_t pin)  { return (Register) regPORToutToggle(pin); }
constexpr Register getRegPORTflag(const uint8_t pin)       { return (Register) regPORTflag(pin); }

// ------------------ SPECIALs ------------------ //
constexpr Register getRegPortCtrl(const uint8_t pin)       { return (Register) regPortCtrl(pin); }
constexpr Register getRegPinCtrl(const uint8_t pin)        { return (Register) regPinCtrl(pin); }
constexpr Register getRegPinCtrlPORTA(const uint8_t pin)   { return (Register) regPinCtrlPORTA(pin); }
  
      
/*     
constexpr uint16_t getAddrBaseVPORT(const uint8_t pin)    { return baseAddr[pin].vport; }
constexpr uint16_t getAddrBasePORT(const uint8_t pin)     { return baseAddr[pin].port; }
//constexpr uint8_t  getAddrOffsetVPORT(const uint8_t pin)  { return static_cast<uint8_t> (reinterpret_cast<uint16_t>(reg) - getAddrBaseVPORT(pin) ); }
//constexpr uint16_t getAddrAbsolut(Register reg) { return reinterpret_cast<uint16_t>(reg); }
*/


constexpr uint16_t getAddrVPORTdir(const uint8_t pin) { return baseAddr[pin].vport + addrOffset.vDir; }
constexpr uint16_t getAddrVPORTin(const uint8_t pin)  { return baseAddr[pin].port + addrOffset.vIn; }
constexpr uint16_t getAddrVPORTout(const uint8_t pin) { return baseAddr[pin].port + addrOffset.vIn; }
constexpr uint16_t getAddrPINCTRL(const uint8_t pin)  { return baseAddr[pin].port + baseAddr[pin].pinCtrl; }
constexpr uint16_t getAddrPORTCTRL(const uint8_t pin) { return baseAddr[pin].port + addrOffset.portCtrl; }

/* funktioniert in Kombination
  constexpr Register bitsdir(const uint8_t p) { return (Register) (getAddrVPORTdir(p)); }
  uint8_t bits(const uint8_t p) { return (*(bitsdir(p) ) ); }
*/

// zusammengefasst so ...
constexpr uint8_t contentDir(const uint8_t p) { return *(uint8_t*) (getAddrVPORTdir(p)); }
uint8_t contentIn(const uint8_t p)  { return *(Register) (getAddrVPORTin(p)); }
uint8_t contentOut(const uint8_t p) { return *(Register) (regVPORTdir(p)); }

// funktioniert: constexpr uint8_t contentdir(const uint8_t p) { return *(uint8_t*) (getRegVPORTdir(p)); }
// funktioniert: constexpr uint8_t contentdir(const uint8_t p) { return *(const_cast<uint8_t*>(getRegVPORTdir(p))); }
// besser:
constexpr uint8_t contentdir(const uint8_t p) { return *(const_cast<uint8_t*>(regVPORTdir(p))); }
constexpr uint8_t contentIn(const uint8_t p)  { return *(const_cast<uint8_t*>(regVPORTin(p)) ); }
constexpr uint8_t contentOut(const uint8_t p) { return *(const_cast<uint8_t*>(regVPORTout(p))); }

/*
uint32_t bitsIn(const uint8_t p)   = return (getValveVPORTin(p)<<8);
uint32_t bitsOut(const uint8_t p)  = return (getValveVPORTout(p)<<8);
uint32_t bitsPin(const uint8_t p)  = return (getValvePINCTRL(p)<<16);
uint32_t bitsPort(const uint8_t p) = return (getValvePORTCTRL(p)<<24);

// Inputs: PortCtrl + PinCtrl + VPORTin + VPORTdir        >>> noch zurechtschieben
constexpr uint32_t readRegisterInput(const uint8_t p)   { return (getValvePORTCTRL(p)<<24) | (getValvePINCTRL(p)<<16) | (getValveVPORTin(p)<<8) | getValveVPORTdir(p);  }

// Outputs: PortCtrl + PinCtrl + VPORTout + VPORTdir 
constexpr uint32_t readRegisterOutput(const uint8_t p)   { return (getValvePORTCTRL(p)<<24) | (getValvePINCTRL(p)<<16) | (getValveVPORTout(p)<<8) | getValveVPORTdir(p);  }

// Interrupts: PortCtrl + PinCtrl + VPORTin + VPORTdir        >>> noch zurechtschieben
// wie Inputs
*/