/*
  Doc_Arduino - german Arduino Forum
  Programmed and tested with: Arduino IDE v1.8.15
  Alternative Pinnamen.
  16.03.2021
  License: GNU GPLv3
*/

#pragma once

constexpr uint8_t pinPC5 { 0};
constexpr uint8_t pinPC4 { 1};
constexpr uint8_t pinPA0 { 2};
constexpr uint8_t pinPF5 { 3};
constexpr uint8_t pinPC6 { 4};
constexpr uint8_t pinPB2 { 5};
constexpr uint8_t pinPF4 { 6};
constexpr uint8_t pinPA1 { 7};
constexpr uint8_t pinPE3 { 8};
constexpr uint8_t pinPB0 { 9};
constexpr uint8_t pinPB1 {10};
constexpr uint8_t pinPE0 {11};
constexpr uint8_t pinPE1 {12};
constexpr uint8_t pinPE2 {13};
constexpr uint8_t pinPD3 {14};
constexpr uint8_t pinPD2 {15};
constexpr uint8_t pinPD1 {16};
constexpr uint8_t pinPD0 {17};
constexpr uint8_t pinPF2 {18};
constexpr uint8_t pinPF3 {19};
constexpr uint8_t pinPD4 {20};
constexpr uint8_t pinPD5 {21};
constexpr uint8_t onboardLed {13};


/*
  Arduino Nano Every PinOut (ATmega4809)
                  _
               __|_|__    
              |       |  
  (D13)  PE2  +       +  PE1  (D12)  
        3.3V  +       +  PE0  (D11)  
  (AREF) PD7  +       +  PB1  (D10)(~)(TCA0 Channel 1)
  (D14)  PD3  +       +  PB0  (D 9)(~)(TCA0 Channel 0)
  (D15)  PD2  +       +  PE3  (D 8)
  (D16)  PD1  +       +  PA1  (D 7) 
  (D17)  PD0  +       +  PF4  (D 6)(~)(TCB0)
  (D18)  PF2  +       +  PB2  (D 5)(~)(TCA0 Channel 2)
  (D19)  PF3  +       +  PC6  (D 4)  
  (D20)  PD4  +       +  PF5  (D 3)(~)(TCB1)  
  (D21)  PD5  +       +  PA0  (D 2) 
        5.0V  +       +  GND
       RESET  +       +  RESET
         GND  +       +  PC5  (D 0) RX1
         VIN  +       +  PC4  (D 1) TX1      
              |_______|  

*/
